require "sketchup.rb"
require "extensions.rb"

$uStrings = LanguageHandler.new("cd_architect")
cd_architect_Extension = SketchupExtension.new $uStrings.GetString("cd_architect"), "cd_architect.rb"
cd_architect_Extension.description=$uStrings.GetString("Architect")
cd_architect_Extension.name= "cd_architect"

Sketchup.register_extension cd_architect_Extension, true

# Run
def exec_on_autoload
  puts("cd_architect loaded.")
end

if( not $cd_architect_menu_loaded )

#tweak Toolbar


	_cd_architect_plugins_menu = UI.menu("Plugins").add_submenu("ARCHILAND")
	
    gp_cd_architect_tb = UI::Toolbar.new("CD ARCHILAND")
   
   
   
  
   
   
#################################   MENUS    #####################################



cmd = UI::Command.new("Simplify Contours") { simplyContours }
cmd.small_icon = "CD_ICONS/ARCHITECT/simplify_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/simplify_24.png"
cmd.tooltip = "Simplify Contours"
cmd.status_bar_text = "Simplify Contours"
cmd.menu_text = "Simplify Contours"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Simplify Contours") { simplyContours }


##################################################################################################




cmd = UI::Command.new("Make Contours") { Contours.calculate }
cmd.small_icon = "CD_ICONS/ARCHITECT/MakeContours_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/MakeContours_24.png"
cmd.tooltip = "Make Contours"
cmd.status_bar_text = "Make Contours"
cmd.menu_text = "Make Contours"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Make Contours") { Contours.calculate }


##################################################################################################



cmd = UI::Command.new("Triangulate points") { triangulate_points }
cmd.small_icon = "CD_ICONS/ARCHITECT/Triangulatepoints_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/Triangulatepoints_24.png"
cmd.tooltip = "Triangulate points"
cmd.status_bar_text = "Triangulate points"
cmd.menu_text = "Triangulate points"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Triangulate points") { triangulate_points }


##################################################################################################

cmd = UI::Command.new("Pointify") { Pointify.start }
cmd.small_icon = "CD_ICONS/ARCHITECT/Pointify_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/Pointify_24.png"
cmd.tooltip = "Pointify"
cmd.status_bar_text = "Pointify"
cmd.menu_text = "Pointify"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Pointify") { Pointify.start }


##################################################################################################
#cmd = UI::Command.new("Convex Hull") { Qhull.mesh }
#cmd.small_icon = "CD_ICONS/ARCHITECT/ConvexHull_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/ConvexHull_24.png"
#cmd.tooltip = "Convex Hull"
#cmd.status_bar_text = "Convex Hull"
#cmd.menu_text = "Convex Hull"
#	gp_cd_architect_tb.add_item(cmd)

#       _cd_architect_plugins_menu.add_item("Convex Hull") { Qhull.mesh }


##################################################################################################
#cmd = UI::Command.new("Voronoi") { Qvoronoi.mesh }
#cmd.small_icon = "CD_ICONS/ARCHITECT/Voronoi_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/Voronoi_24.png"
#cmd.tooltip = "Voronoi"
#cmd.status_bar_text = "Voronoi"
#cmd.menu_text = "Voronoi"
#	gp_cd_architect_tb.add_item(cmd)

#       _cd_architect_plugins_menu.add_item("Voronoi") { Qvoronoi.mesh }


##################################################################################################
#cmd = UI::Command.new("Export CPoints") { Qexport.write }
#cmd.small_icon = "CD_ICONS/ARCHITECT/ExportCPoints_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/ExportCPoints_24.png"
#cmd.tooltip = "Export CPoints"
#cmd.status_bar_text = "Export CPoints"
#cmd.menu_text = "Export CPoints"
#	gp_cd_architect_tb.add_item(cmd)

#       _cd_architect_plugins_menu.add_item("Export CPoints") { Qexport.write }




##################################################################################################
cmd = UI::Command.new("Terrain Reshaper") { trn_terrain }
cmd.small_icon = "CD_ICONS/ARCHITECT/TerrainReshaper_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/TerrainReshaper_24.png"
cmd.tooltip = "Terrain Reshaper"
cmd.status_bar_text = "Terrain Reshaper"
cmd.menu_text = "Terrain Reshaper"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Terrain Reshaper") { trn_terrain }


##################################################################################################





  gp_cd_architect_tb.add_separator








##################################################################################################




cmd = UI::Command.new("Hipped Roof [From Selected Face]"){Roof::hip}
cmd.small_icon = "CD_ICONS/ARCHITECT/roofhipped_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/roofhipped_24.png"
cmd.tooltip = "Hipped Roof [From Selected Face]"
cmd.status_bar_text = "Hipped Roof [From Selected Face]"
cmd.menu_text = "Hipped Roof [From Selected Face]"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Hipped Roof [From Selected Face]"){Roof::hip}


##################################################################################################




cmd = UI::Command.new("Mansard | Sprocket Roof [From Selected Face]"){Roof::mansard}
cmd.small_icon = "CD_ICONS/ARCHITECT/roofmansard_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/roofmansard_24.png"
cmd.tooltip = "Mansard | Sprocket Roof [From Selected Face]"
cmd.status_bar_text = "Mansard | Sprocket Roof [From Selected Face]"
cmd.menu_text = "Mansard | Sprocket Roof [From Selected Face]"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Mansard | Sprocket Roof [From Selected Face]"){Roof::mansard}


##################################################################################################



cmd = UI::Command.new("Gable-Ended Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofGable.new}
cmd.small_icon = "CD_ICONS/ARCHITECT/roofgable_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/roofgable_24.png"
cmd.tooltip = "Gable-Ended Roof [Pick 3 Points]"
cmd.status_bar_text = "Gable-Ended Roof [Pick 3 Points]"
cmd.menu_text = "Gable-Ended Roof [Pick 3 Points]"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Gable-Ended Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofGable.new}


##################################################################################################



cmd = UI::Command.new("Pyramid Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofPyramid.new}
cmd.small_icon = "CD_ICONS/ARCHITECT/roofPyramid_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/roofPyramid_24.png"
cmd.tooltip = "Pyramid Roof [Pick 3 Points]"
cmd.status_bar_text = "Pyramid Roof [Pick 3 Points]"
cmd.menu_text = "Pyramid Roof [Pick 3 Points]"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Pyramid Roof [Pick 3 Points]"){Sketchup.active_model.select_tool RoofPyramid.new}


##################################################################################################



cmd = UI::Command.new("Get Slope [From Selected Face]"){Roof::get_slope}
cmd.small_icon = "CD_ICONS/ARCHITECT/roofslope_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/roofslope_24.png"
cmd.tooltip = "Get Slope [From Selected Face]"
cmd.status_bar_text = "Get Slope [From Selected Face]"
cmd.menu_text = "Get Slope [From Selected Face]"
#	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Get Slope [From Selected Face]"){Roof::get_slope}


##################################################################################################


  gp_cd_architect_tb.add_separator



#cmd = UI::Command.new("Straight Stair") { stairconc }
#cmd.small_icon = "CD_ICONS/ARCHITECT/stairStraight_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/stairStraight_24.png"
#cmd.tooltip = "Straight Stair"
#cmd.status_bar_text = "Straight Stair"
#cmd.menu_text = "Straight Stair"
#	gp_cd_architect_tb.add_item(cmd)

#       _cd_architect_plugins_menu.add_item("Straight Stair") { stairconc }


##################################################################################################





##################################################################################################



cmd = UI::Command.new("Create Stair") { create_stair }
cmd.small_icon = "CD_ICONS/ARCHITECT/stair_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/stair_24.png"
cmd.tooltip = "Create Stair"
cmd.status_bar_text = "Create Stair"
cmd.menu_text = "Create Stair"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Create Stair") { create_stair }

##################################################################################################

	   
	   
cmd = UI::Command.new("Scissor Stair") { stairconcu }
cmd.small_icon = "CD_ICONS/ARCHITECT/stairScissor_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/stairScissor_24.png"
cmd.tooltip = "Scissor Stair"
cmd.status_bar_text = "Scissor Stair"
cmd.menu_text = "Scissor Stair"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Scissor Stair") { stairconcu }


##################################################################################################



cmd = UI::Command.new("90 Left") { stairconcl }
cmd.small_icon = "CD_ICONS/ARCHITECT/stair90left_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/stair90left_24.png"
cmd.tooltip = "90 Left"
cmd.status_bar_text = "90 Left"
cmd.menu_text = "90 Left"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("90 Left") { stairconcl }
##################################################################################################



cmd = UI::Command.new("Spiral Stairs") { spiral_stair }
cmd.small_icon = "CD_ICONS/ARCHITECT/stairSpiral_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/stairSpiral_24.png"
cmd.tooltip = "Spiral Stairs"
cmd.status_bar_text = "Spiral Stairs"
cmd.menu_text = "Spiral Stairs"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Spiral Stairs") { spiral_stair }



##################################################################################################



cmd = UI::Command.new("Create Windows") { Window.create }
cmd.small_icon = "CD_ICONS/ARCHITECT/windows_16.png"
cmd.large_icon = "CD_ICONS/ARCHITECT/windows_24.png"
cmd.tooltip = "Create Windows"
cmd.status_bar_text = "Create Windows"
cmd.menu_text = "Create Windows"
	gp_cd_architect_tb.add_item(cmd)

       _cd_architect_plugins_menu.add_item("Create Windows") { Window.create }


##################################################################################################



#cmd = UI::Command.new("Glass") { Sketchup.active_model.select_tool WindowTools::GlassTool.new }
#cmd.small_icon = "CD_ICONS/ARCHITECT/wglass.png_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/wglass.png_24.png"
#cmd.status_bar_text = "Glass Tool"
#cmd.tooltip = "Glass Tool"
#	gp_cd_architect_tb.add_item(cmd)

#cmd = UI::Command.new("Frame") { Sketchup.active_model.select_tool WindowTools::FrameTool.new }
#cmd.small_icon = "CD_ICONS/ARCHITECT/wframe_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/wframe_24.png"
#cmd.status_bar_text = "Frame Tool"
#cmd.tooltip = "Frame Tool"
#	gp_cd_architect_tb.add_item(cmd)

#cmd = UI::Command.new("Trim") { Sketchup.active_model.select_tool WindowTools::TrimTool.new }
#cmd.small_icon = "CD_ICONS/ARCHITECT/wtrim_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/wtrim_24.png"
#cmd.status_bar_text = "Trim Tool"
#cmd.tooltip = "Trim Tool"
#	gp_cd_architect_tb.add_item(cmd)

#cmd = UI::Command.new("Mullions") { Sketchup.active_model.select_tool WindowTools::MullionTool.new }
#cmd.small_icon = "CD_ICONS/ARCHITECT/wmullion_16.png"
#cmd.large_icon = "CD_ICONS/ARCHITECT/wmullion_24.png"
#cmd.status_bar_text = "Mullion Tool"
#cmd.tooltip = "Mullion Tool"
#	gp_cd_architect_tb.add_item(cmd)




































$cd_architect_menu_loaded = true
end
file_loaded("cd_architect.rb")